
'Just TEXT Code Editor
'version 2M

    'Recently added:
        ' remembers some settings: last file loaded, syntax highlighting, font name
        ' undo feature - but only one level of undo
        ' find (ctrl+f) and replace (ctrl+r)
        ' try to recover lost work if the program/computer crashes

    'Custom behavior:
        ' Ctrl+Arrow will indent / un-indent line(s) of text
        ' F12 will let try to divide by zero - to test the recovery feature

    'Not implemented yet
        ' word-wrap?
        ' horizontal scroll bar

    NOMAINWIN

    DIM fileExists.info$(10,10)

    '+++ global variables
    global JTHandle$, JT.FontWidth, JT.FontHeight, JT.SpecialFlag
    global JT.MaxTextLines,  JT.TotalLines, JT.DisplayLines, JT.DisplayWidth
    global JT.CurX, JT.CurY, JT.OffsetY, JT.OffsetX
    global JT.StartSelectX, JT.StartSelectY, JT.EndSelectX, JT.EndSelectY, JT.Highlight$, JT.Copy$
    global JT.SegID, JT.JumpIsOpen, JT.SyntaxHighlighting
    global JT.ScrollOffsetY, JT.ScrollSizeY
    global JT.RightClickX, JT.RightClickY
    global JT.FileName$, JT.FontName$, JT.PathToJB$
    global JT.SearchFor$, JT.Replace$

    DIM JT.Text$(1), JT.Display$(1), JT.Temp$(1)

    CALL OpenJustText
    WAIT

    SUB pause ms
        timer ms, [cont]
        wait
        [cont]
        timer 0
    END SUB

    '-----------------------------------------------------------------------------------'
    '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
    '------------------------------                    ---------------------------------'
    '++++++++++++++++++++++++++++++   JUST TEXT SUBS   +++++++++++++++++++++++++++++++++'
    '------------------------------                    ---------------------------------'
    '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
    '-----------------------------------------------------------------------------------'
    SUB OpenJustText
        'check how much space the Windows theme takes up
        WindowWidth = 300
        WindowHeight = 200
        OPEN "" FOR graphics_nf_nsb AS #t  ' open a small window
        #t "home;posxy x y"                ' find the center of the usable area
        CLOSE #t                           ' close the small window
        slackX = WindowWidth - (2 * x)     ' difference between selected WindowSize and usable area
        slackY = WindowHeight - (2 * y)

        JT.FontName$="courier_new 10"
        call JTGetSettings

        'setup the Just TEXT window
        JTHandle$="#JTWin.GB"
        JT.FontWidth=8 : JT.FontHeight=16 : JT.SpecialFlag=0
        JTWidth=DisplayWidth-slackX-400 : JTHeight=800
        JT.DisplayLines=int(((JTHeight)/JT.FontHeight)-3)
        JT.DisplayWidth=int(((JTWidth)/JT.FontWidth)-3)
        JT.MaxTextLines=JT.DisplayLines*2 : JT.TotalLines=0
        JT.CurX=0 : JT.CurY=0 : JT.OffsetX=0 : JT.OffsetY=0
        JT.StartSelectX=0 : JT.StartSelectY=0 : JT.EndSelectX=0 : JT.EndSelectY=0 : JT.Highlight$=""
        WindowHeight=JTHeight+slackY+6-JT.FontHeight
        WindowWidth=JTWidth+slackX+26
        UpperLeftX = 8
        UpperLeftY = 50
        graphicbox #JTWin.SB, JTWidth-2, 0, 20, (JT.DisplayLines+1)*JT.FontHeight+4
        graphicbox #JTWin.GB, -1, -1, JTWidth, JTHeight
        menu #JTWin, "&File", "&New", JTNewFile, |, "&Open         F1", JTLoad, "&Save As...   F2", JTSaveAs, "Sa&ve         F3", JTSave
        menu #JTWin, "&Edit", "&Undo      Ctrl+Z", JTUndo, "&Redo", JTRedo, |, "&Find      Ctrl+F", JTSearchPrompt, "&Replace   Ctrl+R", JTReplacePrompt
        menu #JTWin, "&JB", "&Load in Just BASIC IDE", JTJBIDE
        menu #JTWin, "&View", "&Syntax Highlighting", JTToggleSyntaxHighlighting, "&Jump to...", JTJumpAll, "&Refresh screen   F5", JTRefresh

        open "Just TEXT" for window_nf as #JTWin
        #JTWin "trapclose JTQuit"

        'JT scroll bar
        #JTWin.SB "color 110 110 110 ; backcolor 220 220 200 ; size 2"
        #JTWin.SB "down"
        #JTWin.SB "when leftButtonDown JTScrollClick"
        #JTWin.SB "when leftButtonMove JTScrollDrag"
        #JTWin.SB "when leftButtonUp JTScrollUp"

        'JT main graphic window
        #JTHandle$ "down"
        #JTHandle$ "setfocus"
        #JTHandle$ "font ";JT.FontName$
        #JTHandle$ "when characterInput JTKeyPress"
        #JTHandle$ "when leftButtonDown JTClick"
        #JTHandle$ "when leftButtonMove JTDrag"
        #JTHandle$ "when rightButtonDown JTRightDown"
        #JTHandle$ "when rightButtonMove JTRightDrag"
        #JTHandle$ "when rightButtonUp JTRightUp"

        redim JT.Text$(JT.MaxTextLines)
        redim JT.Hide(JT.MaxTextLines)
        redim JT.Display$(JT.DisplayLines)
        #JTHandle$ "place ";JT.FontWidth-2;" 0"
        #JTHandle$ "boxfilled ";JT.FontWidth*JT.DisplayWidth+2;" ";(JT.DisplayLines+1)*JT.FontHeight+4

        if fileExists(DefaultDir$,JT.FileName$) then call JTLoadFile JT.FileName$
        if JT.JumpIsOpen=1 then JT.JumpIsOpen=0 : call JTJumpAll
        call JTShowCursor
        call JTScrollDisplay
        #JTHandle$ "segment JT.SegID"
        #JTHandle$ "flush"
        call JTUpdateScreen
        if fileExists(DefaultDir$,"badexit.JT") then
            notice "Drat! Just TEXT did not shut down properly."
            confirm "You may find lost work in the undo.txt file. Load undo.txt now?"; answer$
            if answer$="yes" then
                call JTLoadFile "undo.txt"
                call JTRefresh
            end if
        else
            open "badexit.JT" for output as #fout
            #fout, "Just TEXT did not shut down properly. You may find lost work in temp.txt or undo.txt file."
            close #fout
        end if
        call JTSaveFile "undo.txt"
    END SUB

    SUB JTQuit handle$
        call JTSaveSettings
        close #JTWin
        if JT.JumpIsOpen=1 then close #JTJump
        if fileExists(DefaultDir$,"undo.txt") then kill "undo.txt"
        if fileExists(DefaultDir$,"temp.txt") then kill "temp.txt"
        if fileExists(DefaultDir$,"badexit.JT") then kill "badexit.JT"
        end
    END SUB

    SUB JTSetupJumpWindow type$
        for i = 0 to JT.TotalLines
            if ((type$="All" or type$="Branch")   and instr(upper$(trim$(JT.Text$(i))),"[")=1        ) OR _
               ((type$="All" or type$="Function") and instr(upper$(trim$(JT.Text$(i))),"FUNCTION")=1 ) OR _
               ((type$="All" or type$="JumpLabels") and instr(upper$(trim$(JT.Text$(i))),"'+++")=1 ) OR _
               ((type$="All" or type$="Sub")      and instr(upper$(trim$(JT.Text$(i))),"SUB")=1      ) then
                    J=J+1
            end if
        next i
        if JT.JumpIsOpen=0 then
            redim JT.JumpList(J)
            redim JT.JumpList$(J)
            J=0
            for i = 0 to JT.TotalLines
                if ((type$="All" or type$="Branch")   and instr(upper$(trim$(JT.Text$(i))),"[")=1        ) OR _
                   ((type$="All" or type$="Function") and instr(upper$(trim$(JT.Text$(i))),"FUNCTION")=1 ) OR _
                   ((type$="All" or type$="JumpLabels") and instr(upper$(trim$(JT.Text$(i))),"'+++")=1 ) OR _
                   ((type$="All" or type$="Sub")      and instr(upper$(trim$(JT.Text$(i))),"SUB")=1      ) then
                       J=J+1
                       JT.JumpList(J)=i
                       JT.JumpList$(J)=trim$(JT.Text$(i))
                end if
            next i
            WindowWidth=800 : WindowHeight=800
            UpperLeftX = 450 : UpperLeftY = 50
            listbox #JTJump.list, JT.JumpList$(), JTJumpEvent, 60, 10, 580, 680
            button #JTJump.default, "Okay", JTJumpClose, UL, 5, 5
            open "Jump to ";type$ for dialog as #JTJump
            #JTJump.list "font courier_new 10"
            #JTJump.list "singleclickselect"
            #JTJump.list "reload"
            #JTJump.list "setfocus"
            #JTJump "trapclose JTJumpClose"
            JT.JumpIsOpen=1
        else
            redim JT.JumpList(J)
            redim JT.JumpList$(J)
            J=0
            for i = 0 to JT.TotalLines
                if ((type$="All" or type$="Branch")   and instr(upper$(trim$(JT.Text$(i))),"[")=1        ) OR _
                   ((type$="All" or type$="Function") and instr(upper$(trim$(JT.Text$(i))),"FUNCTION")=1 ) OR _
                   ((type$="All" or type$="JumpLabels") and instr(upper$(trim$(JT.Text$(i))),"'+++")=1 ) OR _
                   ((type$="All" or type$="Sub")      and instr(upper$(trim$(JT.Text$(i))),"SUB")=1      ) then
                        J=J+1
                        JT.JumpList(J)=i
                        JT.JumpList$(J)=trim$(JT.Text$(i))
                end if
            next i
            #JTJump.list "reload"
            #JTJump.list "setfocus"
        end if
    END SUB

    SUB JTJumpClose handle$
        close #JTJump
        JT.JumpIsOpen=0
    END SUB

    SUB JT msg$
        call pause 200
        'this sub is intended to allow the programmer to send "commands" to the JT window / graphicbox
        call JTHideCursor
        select case word$(msg$,1)
        case "cls"
        ' "cls" is a one word command. It erases all text in the JT window.
            redim JT.Text$(JT.MaxTextLines)
            redim JT.Hide(JT.MaxTextLines)
            JT.TotalLines=0
            JT.CurX=0 : JT.CurY=0
            call JTUpdateScreen
            call JTShowCursor
        case "xy"
        ' "xy ";x;" ";y this command places the cursor after the Xth character in the Yth line,
        ' keep in mind that the first line in the JT window is the 0th line.
            JT.CurX=val(word$(msg$,2)) : JT.CurY=val(word$(msg$,3))
            call JTUpdateScreen
        case "insert"
        ' This command inserts the following text at the current cursor position
            text$=mid$(msg$,8)
            call JTInsertText text$
            call JTUpdateScreen
        case "highlight"
        ' This command highlight from the cursor position to the x y coordinates
        ' specified in msg$
            call JTClick JTHandle$, (JT.CurX+1)*JT.FontWidth, (JT.CurY+1)*JT.FontHeight
            x=(1+val(word$(msg$,2)))*JT.FontWidth : y=(1+val(word$(msg$,3)))*JT.FontHeight
            call JTDrag JTHandle$, x, y
        case "return"
        'this one word command enters a carriage return at the cursor position
            call JTReturn 1
            call JTUpdateScreen
        case "delete"
            call JTSpecialKey chr$(0);chr$(46)
            call JTUpdateScreen
        case "notready"
        ' This is a single word command that prevents the JT window from recieving user input
            'JT scroll bar
            #JTWin.SB "when leftButtonDown "
            #JTWin.SB "when leftButtonMove "
            #JTWin.SB "when leftButtonUp "
            'JT main graphic window
            #JTHandle$ "when characterInput "
            #JTHandle$ "when leftButtonDown "
            #JTHandle$ "when leftButtonMove "
            #JTHandle$ "when rightButtonDown "
            #JTHandle$ "when rightButtonMove "
            #JTHandle$ "when rightButtonUp "
        case "ready"
        ' This is a single word command that readies the JT window to receive user input
            'JT scroll bar
            #JTWin.SB "when leftButtonDown JTScrollClick"
            #JTWin.SB "when leftButtonMove JTScrollDrag"
            #JTWin.SB "when leftButtonUp JTScrollUp"
            'JT main graphic window
            #JTHandle$ "when characterInput JTKeyPress"
            #JTHandle$ "when leftButtonDown JTClick"
            #JTHandle$ "when leftButtonMove JTDrag"
            #JTHandle$ "when rightButtonDown JTRightDown"
            #JTHandle$ "when rightButtonMove JTRightDrag"
            #JTHandle$ "when rightButtonUp JTRightUp"
        case "nomouse"
        ' This is a single word command that prevents the JT window from recieving mouse input
            'JT scroll bar
            #JTWin.SB "when leftButtonDown "
            #JTWin.SB "when leftButtonMove "
            #JTWin.SB "when leftButtonUp "
            'JT main graphic window
            #JTHandle$ "when leftButtonDown "
            #JTHandle$ "when leftButtonMove "
            #JTHandle$ "when rightButtonDown "
            #JTHandle$ "when rightButtonMove "
            #JTHandle$ "when rightButtonUp "
        end select
        call JTShowCursor
    END SUB

    '-------------------------------------------------------------------------------'
    '------------------------------                ---------------------------------'
    '++++++++++++++++++++++++++++++   MENU  SUBS   +++++++++++++++++++++++++++++++++'
    '------------------------------                ---------------------------------'
    '-------------------------------------------------------------------------------'

    SUB JTLoad
        if fileExists(DefaultDir$,JT.FileName$) then
            call JTSaveFile "temp.txt"
            open "temp.txt" for input as #fin
                current$=input$(#fin,lof(#fin))
            close #fin
            open JT.FileName$ for input as #fin
                saved$=input$(#fin,lof(#fin))
            close #fin
            if current$<>saved$ then
                confirm "Open new file and lose all unsaved data?"; answer$
            else
                answer$="yes"
            end if
        else
            answer$="yes"
        end if
        if answer$="yes" then
            filedialog "Open text file", "*.*", fileName$
            if fileName$<>"" then
                call JTLoadFile fileName$
                call JTSaveFile "undo.txt"
                JT.CurY=0
                JT.CurX=0
                call JTUpdateScreen
                call JTScrollDisplay
                if JT.JumpIsOpen then call JTSetupJumpWindow "All"
                JT.FileName$=fileName$
            end if
        end if
    END SUB

    SUB JTSaveAs
        filedialog "Save As...", "*.*", fileName$
        if fileName$<>"" then
            if fileExists(DefaultDir$, fileName$) then
                confirm "Overwrite existing file?"; answer$
            else
                answer$="yes"
            end if
            if answer$="yes" then
                call JTSaveFile fileName$
                JT.FileName$=fileName$
            end if
        end if
    END SUB

    SUB JTSave
        if JT.FileName$<>"" then
            if fileExists(DefaultDir$, fileName$) then
                confirm "Overwrite existing file?"; answer$
            else
                answer$="yes"
            end if
            if answer$="yes" then
                call JTSaveFile fileName$
                JT.FileName$=fileName$
            end if
        else
            notice "You are about to save this file for the first time."
            call JTSaveAs
        end if
    END SUB

    SUB JTJBIDE
        if JT.PathToJB$="" then
            notice "You need to specify the location of the jbasic.exe file"
            filedialog "Where is jbasic.exe?", "jbasic.exe", JT.PathToJB$
        end if
        if JT.PathToJB$<>"" then
            call JTSaveFile "temp.txt"
            run JT.PathToJB$;" ";DefaultDir$;"\temp.txt"
        end if
    END SUB

    SUB JTUndo
        if fileExists(DefaultDir$,"undo.txt") then
            call JTSaveFile "redo.txt"
            call JTLoadFile "undo.txt"
            call JTUpdateScreen
            call JTScrollDisplay
        else
            notice "Can't undo"
        end if
    END SUB

    SUB JTRedo
        if fileExists(DefaultDir$,"redo.txt") then
            call JTLoadFile "redo.txt"
            call JTUpdateScreen
            call JTScrollDisplay
        else
            notice "Can't redo"
        end if
    END SUB

    SUB JTSearch
        if JT.Highlight$="" and JT.SearchFor$="" then
            JT.SearchFor$=word$(trim$(JT.Highlight$),1)
            prompt "Search for..."; JT.SearchFor$
        else
            if JT.SearchFor$="" then JT.SearchFor$=word$(trim$(JT.Highlight$),1)
        end if
        i=JT.CurY
        loc=instr(JT.Text$(i),JT.SearchFor$,JT.CurX+1)
        if loc=0 then
            for i = JT.CurY+1 to JT.TotalLines
                loc=instr(JT.Text$(i),JT.SearchFor$)
                if loc>0 then exit for
            next i
        end if
        if loc>0 then
            JT.CurY=i : JT.OffsetY=i
            JT.CurX=loc
            call JTUpdateScreen
            JT.StartSelectX=JT.CurX-1 : JT.StartSelectY=JT.CurY
            JT.EndSelectX=JT.CurX-1+len(JT.SearchFor$) : JT.EndSelectY=JT.CurY
            call JTShowHighlight
        else
            notice "Not found beyond this point"
        end if
    END SUB

    SUB JTSearchPrompt
        JT.SearchFor$=word$(trim$(JT.Highlight$),1)
        prompt "Search for..."; JT.SearchFor$
        call JTSearch
    END SUB

    SUB JTReplace
        if JT.Highlight$<>"" then
            call JTInsertText JT.Replace$
            call JTUpdateScreen
        end if
    END SUB

    SUB JTReplacePrompt
        if JT.SearchFor$="" then
            JT.SearchFor$=word$(trim$(JT.Highlight$),1)
            prompt "Search for..."; JT.SearchFor$
        end if
        if JT.Highlight$="" then call JTSearch
        JT.ReplacePrompt$=JT.SearchFor$
        p$="Replace ";chr$(34);JT.SearchFor$;chr$(34);" with ?"
        prompt p$; JT.Replace$
        call JTReplace
    END SUB

    SUB JTToggleSyntaxHighlighting
        if JT.SyntaxHighlighting=0 then JT.SyntaxHighlighting=1 else JT.SyntaxHighlighting=0
        for i = 0 to JT.DisplayLines
            JT.Display$(i)=chr$(0)
        next i
        call JTUpdateScreen
    END SUB

    SUB JTJumpAll
        call JTSetupJumpWindow "All"
    END SUB

    '-------------------------------------------------------------------------------'
    '------------------------------                ---------------------------------'
    '++++++++++++++++++++++++++++++   EVENT SUBS   +++++++++++++++++++++++++++++++++'
    '------------------------------                ---------------------------------'
    '-------------------------------------------------------------------------------'

    SUB JTClick handle$, x, y
        call JTHideCursor
        if JT.EndSelectX<>JT.StartSelectX or JT.EndSelectY<>JT.StartSelectY then
            call JTHideHighlight
        end if
        JT.CurY=int((y) / JT.FontHeight)+JT.OffsetY
        if JT.CurY>JT.TotalLines then JT.CurY=JT.TotalLines
        if JT.CurY>JT.DisplayLines+JT.OffsetY then JT.CurY=JT.DisplayLines+JT.OffsetY ': notice JT.DisplayLines
        if JT.CurY<0 then JT.CurY=0
        JT.CurX=int((x-JT.FontWidth+JT.FontWidth/2)/JT.FontWidth)+JT.OffsetX
        if JT.CurX<0 then JT.CurX=0
        if JT.CurX>len(JT.Text$(JT.CurY)) then JT.CurX=len(JT.Text$(JT.CurY))
        JT.StartSelectX=JT.CurX : JT.EndSelectX=0
        JT.StartSelectY=JT.CurY : JT.EndSelectY=0
        JT.Highlight$=""
        JT.EndSelectX=JT.StartSelectX
        JT.EndSelectY=JT.StartSelectY
        call JTUpdateScreen
        call JTShowCursor
    END SUB

    SUB JTDrag handle$, x, y
        call JTHideCursor
        call JTHideHighlight
        new.CurY=int((y) / JT.FontHeight)+JT.OffsetY
        if new.CurY>JT.TotalLines then new.CurY=JT.TotalLines
        if new.CurY<0 then new.CurY=0
        new.CurX=int((x-JT.FontWidth+JT.FontWidth/2)/JT.FontWidth)+JT.OffsetX
        if new.CurX<0 then new.CurX=0
        if new.CurX>len(JT.Text$(new.CurY)) then new.CurX=len(JT.Text$(new.CurY))
        JT.EndSelectX=new.CurX
        JT.EndSelectY=new.CurY
        if JT.EndSelectX<>JT.StartSelectX or JT.EndSelectY<>JT.StartSelectY then
            call JTShowHighlight
        end if
    END SUB

    SUB JTKeyPress handle$, char$
        call JTHideCursor
        'is it printable?
        if asc(char$)>=32 then
            call JTInsertText left$(char$,1)
        else
            call JTSpecialKey char$
        end if
        call JTUpdateScreen
    END SUB

    SUB JTSpecialKey char$
        'notice len(char$);" ";asc(char$);" ";asc(mid$(char$,2,1))
        select case len(char$)
        case 1
            select case asc(right$(char$,1))
            case _VK_RETURN
                    call JTSaveFile "undo.txt"
                    call JTReturn 0
            case _VK_BACK
                    call JTBackspace
            case _VK_TAB
                    call JTTab
            case 6 'CTRL+F
                call JTSearch
            case 3 'CTRL+C
                JT.Copy$=JT.Highlight$
            case 18 'CTRL+R
                call JTReplace
            case 22 'CTRL+V
                call JTHideHighlight
                call JTInsertText JT.Copy$
            case 24 'CTRL+X
                JT.Copy$=JT.Highlight$
                call JTBackspace
            case 26 'CTRL+Z
                call JTUndo
            case else
                'notice len(char$);" ";asc(char$);" ";asc(mid$(char$,2,1))
            end select
        case 2
            select case asc(char$)
            case 0
                select case asc(mid$(char$,2,1))
                case _VK_RIGHT
                    call JTRight
                case _VK_LEFT
                    call JTLeft
                case _VK_UP
                    call JTUp
                case _VK_DOWN
                    call JTDown
                case _VK_DELETE
                    if JT.Highlight$<>"" then
                        call JTBackspace
                    else
                        call JTDelete
                    end if
                case _VK_HOME
                    call JTHome
                case _VK_END
                    call JTEnd
                case _VK_PRIOR
                    call JTPageUp
                case _VK_NEXT
                    call JTPageDown
                case _VK_F1
                    call JTLoad
                case _VK_F2
                    call JTSave
                case _VK_F5
                    call JTRefresh
                case _VK_F12
                    confirm "crash JT now?"; answer$
                    if answer$="yes" then crashMe=1/0
                case else
                    'notice len(char$);" ";asc(char$);" ";asc(mid$(char$,2,1))
                end select
            case 4 'SHIFT
                select case asc(mid$(char$,2,1))
                case 116 'SHIFT + F5
                    call JTJBIDE
                case else
                    'notice len(char$);" ";asc(char$);" ";asc(mid$(char$,2,1))
                end select
            case 8 'CTRL
                select case asc(mid$(char$,2,1))
                case 7'CTRL+G
                    'call JTSearch
                case 37'CTRL+LEFT
                    call JTDedent
                case 39'CTRL+RIGHT
                    call JTIndent
                case else
                    'notice len(char$);" ";asc(char$);" ";asc(mid$(char$,2,1))
                end select
            end select
        end select
    END SUB

    SUB JTRightDown handle$, x, y
        JT.RightClickX=x : JT.RightClickY=y
    END SUB

    SUB JTRightDrag handle$, x, y
        if JT.RightClickY<>y then
            '#JTHandle$ "when rightButtonMove "
            if JT.SyntaxHighlighting then
                JT.tempSyntaxHighlightingOff=1
            else
                JT.tempSyntaxHighlightingOff=0
            end if
            call JTHideCursor
            diff = int( log(abs(JT.RightClickY-y)) )
            if JT.RightClickY<y then JT.CurY=JT.OffsetY+JT.DisplayLines+diff else JT.CurY=JT.OffsetY-diff
            if JT.CurY>JT.TotalLines then JT.CurY=JT.TotalLines
            if JT.CurY<0 then JT.CurY=0
            if JT.tempSyntaxHighlightingOff=1 then JT.SyntaxHighlighting=0
            call JTUpdateScreen
            if JT.tempSyntaxHighlightingOff=1 then JT.SyntaxHighlighting=1
            '#JTHandle$ "when rightButtonMove JTRightDown"
            'JT.RightClickY=y
        end if
    END SUB

    SUB JTRightUp handle$, x, y
        call JTRefresh
    END SUB

    SUB JTScrollClick handle$, x, y
        call JTHideCursor
        JTHeight=JT.DisplayLines*JT.FontHeight
        if JT.DisplayLines>JT.TotalLines then
            percentVisible=1
        else
            percentVisible=JT.DisplayLines/(JT.TotalLines+1)
        end if
        percentDown = JT.OffsetY/(JT.TotalLines+1)
        JT.CurY=int( (y/JTHeight)*JT.TotalLines )
        if JT.CurY>JT.TotalLines then JT.CurY=JT.TotalLines
        if JT.CurY<0 then JT.CurY=0
        call JTUpdateScreen
        #JTHandle$ "setfocus"
    END SUB

    SUB JTScrollDrag handle$, x, y
        if JT.SyntaxHighlighting then
            JT.tempSyntaxHighlightingOff=1
        else
            JT.tempSyntaxHighlightingOff=0
        end if
        call JTHideCursor
        JTHeight=JT.DisplayLines*JT.FontHeight
        if JT.DisplayLines>JT.TotalLines then
            percentVisible=1
        else
            percentVisible=JT.DisplayLines/(JT.TotalLines+1)
        end if
        percentDown = JT.OffsetY/(JT.TotalLines+1)
        JT.CurY=int( (y/JTHeight)*JT.TotalLines )
        if JT.CurY>JT.TotalLines then JT.CurY=JT.TotalLines
        if JT.CurY<0 then JT.CurY=0
        if JT.tempSyntaxHighlightingOff=1 then JT.SyntaxHighlighting=0
        call JTUpdateScreen
        if JT.tempSyntaxHighlightingOff=1 then JT.SyntaxHighlighting=1
        #JTHandle$ "setfocus"
    END SUB

    SUB JTScrollUp handle$, x, y
        for i = 0 to JT.DisplayLines
            JT.Display$(i)=chr$(0)
        next i
        call JTUpdateScreen
    END SUB

    SUB JTJumpEvent handle$
        #JTJump.list "selectionindex? index"
        JT.CurY=JT.JumpList(index)
        if JT.CurY>5 then JT.OffsetY=JT.CurY-5 else JT.OffsetY=0
        if JT.OffsetY+JT.DisplayLines>JT.TotalLines then JT.OffsetY=JT.TotalLines-JT.DisplayLines
        call JTHideCursor
        call JTUpdateScreen
    END SUB

    '-------------------------------------------------------------------------------'
    '------------------------------                ---------------------------------'
    '++++++++++++++++++++++++   TEXT MANIPULATION SUBS   +++++++++++++++++++++++++++'
    '------------------------------                ---------------------------------'
    '-------------------------------------------------------------------------------'
    SUB JTInsertText char$
        if JT.Highlight$<>"" then
            call JTDeleteHighlighted
        end if
        if instr(char$,chr$(13))=0 then
            JT.Text$(JT.CurY) = MID$(JT.Text$(JT.CurY),1,JT.CurX)  ;  char$  ;  MID$(JT.Text$(JT.CurY),JT.CurX+1)
            JT.CurX=JT.CurX+len(char$)
        else
            w=1
            lineToInsert$=word$(char$,w,chr$(13))
            while lineToInsert$<>""
                    if w>1 then call JTReturn 1
                    if lineToInsert$=chr$(13) then lineToInsert$=""
                    JT.Text$(JT.CurY) = MID$(JT.Text$(JT.CurY),1,JT.CurX) ; lineToInsert$ ; MID$(JT.Text$(JT.CurY),JT.CurX+1)
                    JT.CurX=JT.CurX+len(lineToInsert$)
                    'call JTReturn
                w=w+1
                lineToInsert$=word$(char$,w,chr$(13))
            wend

        end if
    END SUB

    SUB JTDeleteHighlighted
        call JTSaveFile "undo.txt"
        select case
        case JT.StartSelectY<JT.EndSelectY
            lowY=JT.StartSelectY
            lowX=JT.StartSelectX
            hiY=JT.EndSelectY
            hiX=JT.EndSelectX
        case JT.StartSelectY=JT.EndSelectY
            lowY=JT.EndSelectY
            hiY=JT.EndSelectY
            if JT.StartSelectX<JT.EndSelectX then
                lowX=JT.StartSelectX
                hiX=JT.EndSelectX
            else
                lowX=JT.EndSelectX
                hiX=JT.StartSelectX
            end if
        case JT.StartSelectY>JT.EndSelectY
            lowY=JT.EndSelectY
            lowX=JT.EndSelectX
            hiY=JT.StartSelectY
            hiX=JT.StartSelectX
        end select
        for y = lowY to hiY
            if y=lowY then
                x1=lowX
                new.CurY=y
                new.CurX=x1
            else
                x1=0
            end if
            if y=hiY then x2=hiX else x2=len(JT.Text$(y))
            toHighlight$=mid$(JT.Text$(y),x1+1,x2-x1)
            JT.Text$(y)= mid$(JT.Text$(y),1,x1);mid$(JT.Text$(y),x2+1)
        next y
        for linesToDelete = 1 to hiY-lowY
            JT.CurY=lowY
            JT.CurX=len(JT.Text$(JT.CurY))
            call JTDelete
        next linesToDelete
        JT.Highlight$=""
        JT.StartSelectX=JT.CurX : JT.EndSelectX=JT.CurX
        JT.StartSelectY=JT.CurY : JT.EndSelectY=JT.CurY
        JT.CurY=new.CurY : JT.CurX=new.CurX
    END SUB

    '---------------------------------------------------------------------------------'
    '------------------------------                  ---------------------------------'
    '++++++++++++++++++++++++++++++   DISPLAY SUBS   +++++++++++++++++++++++++++++++++'
    '------------------------------                  ---------------------------------'
    '---------------------------------------------------------------------------------'

    SUB JTUpdateScreen
        #JTHandle$ "when characterInput "
        if JT.CurY<JT.OffsetY then JT.OffsetY=JT.CurY
        if JT.CurY>JT.DisplayLines+JT.OffsetY then JT.OffsetY=JT.CurY-JT.DisplayLines
        if JT.CurX-JT.OffsetX>=JT.DisplayWidth then JT.OffsetX=JT.CurX-JT.DisplayWidth
        if JT.CurX<JT.OffsetX then JT.OffsetX=JT.CurX
        if JT.ScrollOffsetY<>JT.OffsetY or _
            (JT.ScrollSizeY<>(JT.DisplayLines+1)/(JT.TotalLines+1) and JT.ScrollSizeY<>1) then call JTScrollDisplay
        h=0
        for L = 0 to JT.DisplayLines
            toShow$=mid$(JT.Text$(L+JT.OffsetY), JT.OffsetX+1, JT.OffsetX+1+JT.DisplayWidth-2)
            if NOT(JT.Display$(L)=toShow$) then
                if JT.SyntaxHighlighting=0 then
                    #JTHandle$ "place ";JT.FontWidth;" ";JT.FontHeight+L*JT.FontHeight
                    #JTHandle$ "|";toShow$;space$(JT.DisplayWidth-len(toShow$)-1)
                else
                    call JTShowColored toShow$, L*JT.FontHeight, L+JT.OffsetY
                    #JTHandle$ "place ";JT.FontWidth+JT.FontWidth*len(toShow$);" ";JT.FontHeight+L*JT.FontHeight
                    #JTHandle$ "\";space$(JT.DisplayWidth-len(toShow$)-1)
                end if
                JT.Display$(L)=toShow$
            end if
        next L
        call JTShowCursor
        if JT.EndSelectX<>JT.StartSelectX or JT.EndSelectY<>JT.StartSelectY then call JTShowHighlight
        #JTHandle$ "place ";JT.FontWidth-2;" 0"
        #JTHandle$ "box ";JT.FontWidth*JT.DisplayWidth+2;" ";(JT.DisplayLines+1)*JT.FontHeight+4
        #JTHandle$ "delsegment ";JT.SegID
        #JTHandle$ "segment JT.SegID"
        #JTHandle$ "getbmp temp 0 0 800 800"
        #JTHandle$ "drawbmp temp 0 0"
        #JTHandle$ "flush"
        #JTHandle$ "when characterInput JTKeyPress"
    END SUB

    SUB JTShowCursor
        #JTHandle$ "color red"
        #JTHandle$ "place ";(JT.CurX+1-JT.OffsetX)*JT.FontWidth;" ";(JT.CurY-JT.OffsetY-JT.linesHidAbove)*JT.FontHeight+4
        #JTHandle$ "goto ";(JT.CurX+1-JT.OffsetX)*JT.FontWidth;" ";(JT.CurY-JT.OffsetY+1-JT.linesHidAbove)*JT.FontHeight
        #JTHandle$ "color black"
    END SUB

    SUB JTHideCursor
        #JTHandle$ "color white"
        #JTHandle$ "place ";(JT.CurX+1-JT.OffsetX)*JT.FontWidth;" ";(JT.CurY-JT.OffsetY-JT.linesHidAbove)*JT.FontHeight+4
        #JTHandle$ "goto ";(JT.CurX+1-JT.OffsetX)*JT.FontWidth;" ";(JT.CurY-JT.OffsetY+1-JT.linesHidAbove)*JT.FontHeight
        #JTHandle$ "color black"
    END SUB

    SUB JTShowHighlight
        JT.Highlight$=""
        select case
        case JT.StartSelectY<JT.EndSelectY
            lowY=JT.StartSelectY
            lowX=JT.StartSelectX
            hiY=JT.EndSelectY
            hiX=JT.EndSelectX
        case JT.StartSelectY=JT.EndSelectY
            lowY=JT.EndSelectY
            hiY=JT.EndSelectY
            if JT.StartSelectX<JT.EndSelectX then
                lowX=JT.StartSelectX
                hiX=JT.EndSelectX
            else
                lowX=JT.EndSelectX
                hiX=JT.StartSelectX
            end if
        case JT.StartSelectY>JT.EndSelectY
            lowY=JT.EndSelectY
            lowX=JT.EndSelectX
            hiY=JT.StartSelectY
            hiX=JT.StartSelectX
        end select
        for y = lowY to hiY
            if y=lowY then x1=lowX else x1=0
            if y=hiY then x2=hiX else x2=len(JT.Text$(y))
            toHighlight$=mid$(JT.Text$(y),x1+1,x2-x1)
            screenY=JT.FontHeight+(y-JT.OffsetY)*JT.FontHeight
            screenX=JT.FontWidth+(x1-JT.OffsetX)*JT.FontWidth
            #JTHandle$ "color white ; backcolor 0 140 255"
            #JTHandle$ "place ";screenX;" ";screenY
            #JTHandle$ "\";mid$(toHighlight$,1,JT.DisplayWidth-1)
            if y<=JT.DisplayLines then JT.Display$(y-JT.OffsetY)=chr$(0)
            JT.Highlight$=JT.Highlight$;toHighlight$
            if x2=len(JT.Text$(y)) AND y<hiY then JT.Highlight$=JT.Highlight$;CHR$(13)
        next y
        #JTHandle$ "color black ; backcolor white"
    END SUB

    SUB JTHideHighlight
        select case
        case JT.StartSelectY<JT.EndSelectY
            lowY=JT.StartSelectY
            lowX=JT.StartSelectX
            hiY=JT.EndSelectY
            hiX=JT.EndSelectX
        case JT.StartSelectY=JT.EndSelectY
            lowY=JT.EndSelectY
            hiY=JT.EndSelectY
            if JT.StartSelectX<JT.EndSelectX then
                lowX=JT.StartSelectX
                hiX=JT.EndSelectX
            else
                lowX=JT.EndSelectX
                hiX=JT.StartSelectX
            end if
        case JT.StartSelectY>JT.EndSelectY
            lowY=JT.EndSelectY
            lowX=JT.EndSelectX
            hiY=JT.StartSelectY
            hiX=JT.StartSelectX
        end select
        for y = lowY to hiY
            if y=lowY then x1=lowX else x1=0
            if y=hiY then x2=hiX else x2=len(JT.Text$(y))
            toHighlight$=mid$(JT.Text$(y),x1+1,x2-x1)
            screenY=JT.FontHeight+(y-JT.OffsetY)*JT.FontHeight
            screenX=JT.FontWidth+(x1-JT.OffsetX)*JT.FontWidth
            #JTHandle$ "color black ; backcolor white"
            #JTHandle$ "place ";screenX;" ";screenY
            #JTHandle$ "\";mid$(toHighlight$,1,JT.DisplayWidth-1)
            JT.Display$(y-JT.OffsetY)=chr$(0)
        next y
        #JTHandle$ "color black ; backcolor white"
    END SUB

    SUB JTScrollDisplay
        call JTUnHighlight
        if JT.DisplayLines+1>JT.TotalLines then
            percentVisible=1
        else
            percentVisible=(JT.DisplayLines+1)/(JT.TotalLines+1)
        end if
        percentDown=JT.OffsetY/(JT.TotalLines+1)
        JT.ScrollOffsetY=JT.OffsetY
        JT.ScrollSizeY=percentVisible
        #JTWin.SB "fill 220 220 220"
        #JTWin.SB "place 1 ";percentDown*((JT.DisplayLines+1)*JT.FontHeight)+1
        #JTWin.SB "boxfilled 18 ";(percentDown*((JT.DisplayLines+1)*JT.FontHeight)+(percentVisible*((JT.DisplayLines+1)*JT.FontHeight)))+2
    END SUB

    SUB JTRefresh
        for i = 0 to JT.DisplayLines
            JT.Display$(i)=chr$(0)
        next i
        call JTUpdateScreen
    END SUB

    SUB JTShowColored lineToColor$, LY, thisLine

        'setup character lists
        numberList$=".1234567890"
        alphaNumeric$="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz.1234567890"
        alphaNumeric$=alphaNumeric$;"$";numberList$

        'setup reserved lists
        reservedWordList$=" AND, APPEND, AS, BEEP, BMPBUTTON, BMPSAVE, BOOLEAN, BUTTON, BYREF, CALL, CASE, CHECKBOX, CLOSE, CLS, COMBOBOX, CONFIRM, DATA, DIALOG, DIM, DO, DUMP, ELSE, END, ERROR, EXIT, FIELD, FILEDIALOG, FILES, FOR, FUNCTION, GET, GLOBAL, GOSUB, GOTO, GRAPHICBOX, GRAPHICS, GROUPBOX, IF, INPUT, KILL, LET, LINE, LISTBOX, LOADBMP, LONG, LOOP, LPRINT, MAINWIN, MAPHANDLE, MENU, MOD, NAME, NEXT, NOMAINWIN, NONE, NOTICE, ON, ONCOMERROR, OR, OPEN, OUTPUT,  PLAYMIDI, PLAYWAVE, PRINT, PROMPT, PUT, RADIOBUTTON, RANDOM, RANDOMIZE, READ, READJOYSTICK, REDIM, REM, RESTORE, RETURN, RUN, SCAN, SELECT, STATICTEXT, STOP, STOPMIDI, SUB, TEXT, TEXTBOX, TEXTEDITOR, THEN, TIMER, TO, UNLOADBMP, UNTIL, WAIT, WINDOW, WEND, WHILE, WORD, XOR,"
        reservedFunctionList$=" ABS(, ACS(, ASC(, ASN(, ATN(, CHR$(, COS(, DATE$(, EOF(, EXP(, INPUT$(, INSTR(, INT(, LEFT$(, LEN(, LOF(, LOG(, LOWER$(, MIDIPOS(, MID$(, MKDIR(, NOT(, RIGHT$(, RMDIR(, RND(, SIN(, SPACE$(, SQR(, STR$(, TAB(, TAN(, TIME$(, TRIM$(, TXCOUNT(, UPPER$(, USING(, VAL(, WORD$(,"

        L=len(lineToColor$)

        state=0 '0=nothing, 1=number, 2=variable, 3=reserved, 4=other, 5=string literal, 6=function, 7=comment, 8=label
        item$=""

        x=1 : y=1
        for i = 1 to L
            t$=mid$(lineToColor$,i,1)
            select case state
            case 0 ' item$ is empty
                select case
                case instr(numberList$,t$)>0
                    state=1
                    item$=t$
                case instr(alphaNumeric$,t$)>0
                    state=2
                    item$=t$
                case t$=" ",t$=chr$(9),t$=chr$(13),t$=chr$(10)
                    'gosub [out]
                    state=0
                    gosub [out]
                    item$=""
                case t$=chr$(34)
                    state=5
                    item$=t$
                case t$="'"
                    state=7
                    item$=t$
                case t$="["
                    state=8
                    item$=t$
                case else
                    state=4
                    item$=t$
                end select
            case 1 'IT IS A NUMBER
                select case
                case instr(numberList$,t$)>0
                    item$=item$;t$
                case instr(alphaNumeric$,t$)>0
                    gosub [out]
                    state=2
                    item$=t$
                case t$=" ",t$=chr$(9),t$=chr$(13),t$=chr$(10)
                    gosub [out]
                    state=0
                    gosub [out]
                    item$=""
                case t$=chr$(34)
                    gosub [out]
                    state=5
                    item$=t$
                case t$="'"
                    gosub [out]
                    state=7
                    item$=t$
                case else
                    gosub [out]
                    state=4
                    item$=t$
                end select
            case 2 'so far looks like variable
                select case
                case instr(alphaNumeric$,t$)>0
                    item$=item$;t$
                    if instr(reservedWordList$,upper$(" ";item$;","))>0 then state=3
                case t$=" ",t$=chr$(9),t$=chr$(13),t$=chr$(10)
                    gosub [out]
                    state=0
                    gosub [out]
                    item$=""
                case t$=chr$(34)
                    gosub [out]
                    state=5
                    item$=t$
                case t$="'"
                    gosub [out]
                    state=7
                    item$=t$
                case t$="("
                    item$=item$;t$
                    if instr(reservedFunctionList$,upper$(" ";item$;","))>0 then
                        state=6
                        gosub [out]
                        state=0
                        item$=""
                    else
                        item$=left$(item$,len(item$)-1)
                        gosub [out]
                        state=4
                        item$=t$
                    end if
                case else
                    gosub [out]
                    state=4
                    item$=t$
                end select
            case 3 'so far it is reserved
                select case
                case instr(alphaNumeric$,t$)>0
                    item$=item$;t$
                if instr(reservedWordList$,upper$(" ";item$;","))>0 then state=3 else state=2
            case t$=" ",t$=chr$(9),t$=chr$(13),t$=chr$(10)
                gosub [out]
                state=0
                gosub [out]
                item$=""
            case t$=chr$(34)
                gosub [out]
                state=5
                item$=t$
            case t$="'"
                gosub [out]
                state=7
                item$=t$
            case else
                gosub [out]
                state=4
                item$=t$
            end select
            case 4 'something else
                select case
                case instr(numberList$,t$)>0
                    gosub [out]
                    state=1
                    item$=t$
                case instr(alphaNumeric$,t$)>0
                    gosub [out]
                    state=2
                    item$=t$
                case t$=" ",t$=chr$(9),t$=chr$(13),t$=chr$(10)
                    gosub [out]
                    state=0
                    gosub [out]
                    item$=""
                case t$=chr$(34)
                    gosub [out]
                    state=5
                    item$=t$
                case t$="'"
                    gosub [out]
                    state=7
                    item$=t$
                case else
                    item$=item$;t$
                end select
            case 5 'string literal
                select case
                case t$=chr$(34)
                    item$=item$;t$
                    gosub [out]
                    state=0
                    item$=""
                case t$=chr$(13),t$=chr$(10)
                    state=4
                    gosub [out]
                    state=0
                    item$=""
                case else
                    item$=item$;t$
                end select
            case 7 'it is a comment
                if t$=chr$(13) then
                    gosub [out]
                    state=0
                    gosub [out]
                    item$=""
                else
                    item$=item$;t$
                end if
            case 8 'it is a label
                select case
                case t$="]"
                    state=4
                    item$=item$;t$
                    gosub [out]
                    state=0
                    item$=""
                case t$=chr$(13),t$=chr$(10)
                    state=4
                    gosub [out]
                    state=0
                    item$=""
                case else
                    item$=item$;t$
                end select
            end select 'case state
        next i
        if item$<>"" then gosub [out]
        goto [subOver]
        [out]
            select case state
            case 0
                if t$=chr$(13) then

                else
                    #JTHandle$ "place ";x*JT.FontWidth;" ";y*JT.FontHeight+LY
                    item$=t$'#JTHandle$ "\";t$
                    'x=x+1
                end if
            case 1
                'print "{NUMBER=";item$;"}";
                #JTHandle$ "color red"
                #JTHandle$ "place ";x*JT.FontWidth;" ";y*JT.FontHeight+LY
            case 2
                'print "{VARIABLE=";item$;"}";
                count=0
                for variableCountLine = 0 to thisLine-1'JT.TotalLines
                    loc=instr(JT.Text$(variableCountLine),item$)
                    if loc>0 and _
                        NOT(instr(alphaNumeric$,mid$(JT.Text$(variableCountLine),loc-1,1))) and _
                        NOT(instr(alphaNumeric$,mid$(JT.Text$(variableCountLine),loc+len(item$),1))) then
                        count=count+1 : exit for
                    end if
                next variableCountLine
                if count=0 then
                    for variableCountLine = thisLine+1 to JT.TotalLines
                        loc=instr(JT.Text$(variableCountLine),item$)
                        if loc>0 and _
                            NOT(instr(alphaNumeric$,mid$(JT.Text$(variableCountLine),loc-1,1))) and _
                            NOT(instr(alphaNumeric$,mid$(JT.Text$(variableCountLine),loc+len(item$),1))) then
                            count=count+1 : exit for
                        end if
                    next variableCountLine
                end if
                if count>0 then
                    #JTHandle$ "color 0 100 120"
                else
                    #JTHandle$ "color 180 40 0"
                    #JTHandle$ "backcolor 255 255 160"
                end if
                #JTHandle$ "place ";x*JT.FontWidth;" ";y*JT.FontHeight+LY
            case 3
                'print "{RESERVED=";item$;"}";
                #JTHandle$ "color blue"
                #JTHandle$ "place ";x*JT.FontWidth;" ";y*JT.FontHeight+LY
            case 4
                'print item$;
                #JTHandle$ "color black"
                #JTHandle$ "place ";x*JT.FontWidth;" ";y*JT.FontHeight+LY
            case 5
                'print "{STRING=";item$;"}";
                #JTHandle$ "color darkgreen"
                #JTHandle$ "place ";x*JT.FontWidth;" ";y*JT.FontHeight+LY
            case 6
                'print "{FUNCTION=";item$;"}";
                #JTHandle$ "color darkpink"
                #JTHandle$ "place ";x*JT.FontWidth;" ";y*JT.FontHeight+LY
            case 7
                'print "{COMMENT=";item$;"}";
                #JTHandle$ "color 100 100 100"
                #JTHandle$ "place ";x*JT.FontWidth;" ";y*JT.FontHeight+LY
            case else
                'print "{[out]else=";item$;"}";
                #JTHandle$ "color black"
                #JTHandle$ "place ";x*JT.FontWidth;" ";y*JT.FontHeight+LY
            end select
            if instr(item$,"\") then #JTHandle$ "|";item$ else #JTHandle$ "\";item$
            #JTHandle$ "backcolor white"
            x=x+len(item$)
        RETURN
        [subOver]
    END SUB

    '-------------------------------------------------------------------------------------'
    '------------------------------                      ---------------------------------'
    '++++++++++++++++++++++++++++++   Special Key SUBS   +++++++++++++++++++++++++++++++++'
    '------------------------------                      ---------------------------------'
    '-------------------------------------------------------------------------------------'

    SUB JTReturn skipAutoIndent
        if JT.Highlight$<>"" then
            call JTDeleteHighlighted
        end if
        if JT.TotalLines=JT.MaxTextLines then call JTRedoMaxTextLines
        shiftDown$=mid$(JT.Text$(JT.CurY),JT.CurX+1)
        for y = JT.TotalLines+1 to JT.CurY+1 step -1
            JT.Text$(y)=JT.Text$(y-1)
        next y
        JT.Text$(JT.CurY+1)=shiftDown$
        JT.Text$(JT.CurY)=mid$(JT.Text$(JT.CurY),1,JT.CurX)
        JT.CurY=JT.CurY+1
        JT.CurX=0
        JT.TotalLines=JT.TotalLines+1
        'auto indent
        if not(skipAutoIndent) then
            whitespace=len(JT.Text$(JT.CurY-1))-len(trim$(JT.Text$(JT.CurY-1)))
            JT.Text$(JT.CurY)=space$(whitespace);JT.Text$(JT.CurY)
            JT.CurX=whitespace
        end if
    END SUB

    SUB JTRight
        if JT.Highlight$<>"" then
            if JT.StartSelectY>JT.EndSelectY OR _
                (JT.StartSelectY=JT.EndSelectY and JT.StartSelectX>JT.EndSelectX) then
                JT.CurX=JT.StartSelectX
                JT.CurY=JT.StartSelectY
            else
                JT.CurX=JT.EndSelectX
                JT.CurY=JT.EndSelectY
            end if
        else
            if JT.CurX<len(JT.Text$(JT.CurY)) then
                JT.CurX=JT.CurX+1
            else
                if JT.CurY<JT.TotalLines then
                    JT.CurX=0
                    JT.CurY=JT.CurY+1
                else
                    'call JTReturn
                end if
            end if
        end if
        call JTUnHighlight
    END SUB

    SUB JTLeft
        if JT.Highlight$<>"" then
            if JT.StartSelectY<JT.EndSelectY OR _
                (JT.StartSelectY=JT.EndSelectY AND JT.StartSelectX<JT.EndSelectX) then
                JT.CurX=JT.StartSelectX
                JT.CurY=JT.StartSelectY
            else
                JT.CurX=JT.EndSelectX
                JT.CurY=JT.EndSelectY
            end if
        else
            if JT.CurX>0 then
                JT.CurX=JT.CurX-1
            else
                if JT.CurY>0 then
                    JT.CurY=JT.CurY-1
                    JT.CurX=len(JT.Text$(JT.CurY))
                end if
            end if
        end if
        call JTUnHighlight
    END SUB

    SUB JTUp
        if JT.CurY>0 then
            JT.CurY=JT.CurY-1
            if JT.CurX>len(JT.Text$(JT.CurY)) then JT.CurX=len(JT.Text$(JT.CurY))
            'slide
            if JT.CurY<JT.OffsetY then
                JT.OffsetY=JT.CurY
                #JTHandle$ "getbmp temp 0 1 ";JT.DisplayWidth*JT.FontWidth;" ";(JT.DisplayLines)*JT.FontHeight
                '#JTHandle$ "cls"
                #JTHandle$ "drawbmp temp 0 ";JT.FontHeight+1
                for L = JT.DisplayLines to 1 step -1
                    JT.Display$(L)=JT.Display$(L-1)
                next L
            end if
        end if
        call JTUnHighlight
    END SUB

    SUB JTDown
        if JT.CurY<JT.TotalLines then
            JT.CurY=JT.CurY+1
            if JT.CurX>len(JT.Text$(JT.CurY)) then JT.CurX=len(JT.Text$(JT.CurY))
            'slide
            if JT.CurY>JT.DisplayLines+JT.OffsetY then
                JT.OffsetY=JT.CurY-JT.DisplayLines
                #JTHandle$ "getbmp temp 0 ";JT.FontHeight+3;" ";JT.DisplayWidth*JT.FontWidth;" ";(JT.DisplayLines)*JT.FontHeight
                '#JTHandle$ "cls"
                #JTHandle$ "drawbmp temp 0 3"
                for L = 0 to JT.DisplayLines-1
                    JT.Display$(L)=JT.Display$(L+1)
                next L
            end if
        end if
        call JTUnHighlight
    END SUB

    SUB JTBackspace
        if JT.Highlight$<>"" then
            call JTDeleteHighlighted
            call JTReturn 1
        end if
        if JT.CurX>0 then

            'auto-whitepace backup
            if mid$(JT.Text$(JT.CurY),1,JT.CurX)=space$(len(mid$(JT.Text$(JT.CurY),1,JT.CurX))) then
                oddwhitespace = len(mid$(JT.Text$(JT.CurY),1,JT.CurX)) mod 4
                if oddwhitespace=0 then whitespace=4 else whitespace=oddwhitespace
                JT.Text$(JT.CurY)=mid$(JT.Text$(JT.CurY),1,JT.CurX-whitespace) ; mid$(JT.Text$(JT.CurY),JT.CurX+1)
                JT.CurX=JT.CurX-whitespace
            else
                JT.Text$(JT.CurY)=mid$(JT.Text$(JT.CurY),1,JT.CurX-1) ; mid$(JT.Text$(JT.CurY),JT.CurX+1)
                JT.CurX=JT.CurX-1
            end if
        else
            if JT.CurY>0 then
                newX=len(JT.Text$(JT.CurY-1))
                for y = JT.CurY to JT.TotalLines
                    JT.Text$(y-1)=JT.Text$(y-1);JT.Text$(y)
                    JT.Text$(y)=""
                next y
                JT.Text$(JT.TotalLines)=""
                JT.TotalLines=JT.TotalLines-1
                JT.CurY=JT.CurY-1 : JT.CurX=newX
            else
                'nothing
            end if
        end if
    END SUB

    SUB JTTab
        for i = 1 to 4
            call JTInsertText " "
        next i
    END SUB

    SUB JTPageUp
        if JT.CurY>JT.DisplayLines+1 then JT.CurY=JT.CurY-JT.DisplayLines-1 else JT.CurY=0
    END SUB

    SUB JTPageDown
        if JT.CurY+JT.DisplayLines+1<JT.TotalLines then JT.CurY=JT.CurY+JT.DisplayLines+1 else JT.CurY=JT.TotalLines
    END SUB

    SUB JTHome
        JT.CurX=0
        call JTUnHighlight
    END SUB

    SUB JTEnd
        JT.CurX=len(JT.Text$(JT.CurY))
        call JTUnHighlight
    END SUB

    SUB JTDelete
            if JT.CurX<len(JT.Text$(JT.CurY)) then
                JT.Text$(JT.CurY)=mid$(JT.Text$(JT.CurY),1,JT.CurX) ; mid$(JT.Text$(JT.CurY),JT.CurX+2)
            else
                if JT.CurY<JT.TotalLines then
                    for y = JT.CurY+1 to JT.TotalLines
                        JT.Text$(y-1)=JT.Text$(y-1);JT.Text$(y)
                        JT.Text$(y)=""
                    next y
                    JT.Text$(JT.TotalLines)=""
                    JT.TotalLines=JT.TotalLines-1
                end if
            end if
    END SUB

    SUB JTIndent
        if JT.Highlight$="" then
            new.CurY=JT.CurY
            new.CurX=JT.CurX+4
            JT.CurX=0
            for i = 1 to 4
                call JTInsertText " "
            next i
            JT.CurX=new.CurX
        else
            if JT.StartSelectY<JT.EndSelectY then new.CurY=JT.StartSelectY else new.CurY=JT.EndSelectY
            JT.Highlight$=""
            for y = JT.StartSelectY to JT.EndSelectY step 1-2*(JT.EndSelectY<JT.StartSelectY)
                JT.CurY=y : JT.CurX=0
                for i = 1 to 4
                    call JTInsertText " "
                next i
            next y
            JT.CurY=new.CurY
            JT.CurX=0
        end if
        if JT.StartSelectY>JT.EndSelectY then
            JT.StartSelectX=len(JT.Text$(JT.StartSelectY))
            JT.EndSelectX=0
        else
            JT.EndSelectX=len(JT.Text$(JT.EndSelectY))
            JT.StartSelectX=0
        end if
        call JTShowHighlight
    END SUB

    SUB JTDedent
        if JT.Highlight$="" then
            new.CurX=JT.CurX
            JT.CurX=0
            for i = 1 to 4
                if left$(JT.Text$(JT.CurY),1)=" " then
                    call JTDelete
                    new.CurX=new.CurX-1
                end if
            next i
            JT.CurX=new.CurX
        else
            if JT.StartSelectY<JT.EndSelectY then new.CurY=JT.StartSelectY else new.CurY=JT.EndSelectY
            JT.CurX=0
            JT.Highlight$=""
            for y = JT.StartSelectY to JT.EndSelectY step 1-2*(JT.EndSelectY<JT.StartSelectY)
                JT.CurY=y
                for i = 1 to 4
                    if left$(JT.Text$(JT.CurY),1)=" " then
                        call JTDelete
                        new.CurX=new.CurX-1
                    end if
                next i
            next y
            JT.CurY=new.CurY
            JT.CurX=0'new.CurX
        end if
        if JT.StartSelectY>JT.EndSelectY then
            JT.StartSelectX=len(JT.Text$(JT.StartSelectY))
            JT.EndSelectX=0
        else
            JT.EndSelectX=len(JT.Text$(JT.EndSelectY))
            JT.StartSelectX=0
        end if
        call JTShowHighlight
    END SUB

    '-------------------------------------------------------------------------------'
    '------------------------------                ---------------------------------'
    '++++++++++++++++++++++++++++++   OTHER SUBS   +++++++++++++++++++++++++++++++++'
    '------------------------------                ---------------------------------'
    '-------------------------------------------------------------------------------'

    SUB JTRedoMaxTextLines
        newMax=JT.MaxTextLines+1000
        redim JT.Temp$(JT.MaxTextLines)
        redim JT.HideTemp(JT.MaxTextLines)
        for i = 0 to JT.MaxTextLines
            JT.Temp$(i)=JT.Text$(i)
            JT.HideTemp(i)=JT.Hide(i)
        next i
        redim JT.Text$(newMax)
        redim JT.Hide(newMax)
        for i = 0 to JT.MaxTextLines
            JT.Text$(i)=JT.Temp$(i)
            JT.Hide(i)=JT.HideTemp(i)
        next i
        JT.MaxTextLines=newMax
        redim JT.Temp$(1)
        redim JT.HideTemp(1)
    END SUB

    SUB JTUnHighlight
        JT.Highlight$=""
        JT.EndSelectX=JT.StartSelectX
        JT.EndSelectY=JT.StartSelectY
    END SUB

    '-------------------------------------------------------------------------------'
    '------------------------------                ---------------------------------'
    '++++++++++++++++++++++++++++++   FILE  SUBS   +++++++++++++++++++++++++++++++++'
    '------------------------------                ---------------------------------'
    '-------------------------------------------------------------------------------'

    SUB JTNewFile
        call JTSaveFile "temp.txt"
        open "temp.txt" for input as #fin
        current$=input$(#fin,lof(#fin))
        close #fin
        if fileExists(DefaultDir$,JT.FileName$) then
            open JT.FileName$ for input as #fin
            saved$=input$(#fin,lof(#fin))
            close #fin
        end if
        if current$<>saved$ then
            confirm "Open new file and lose all unsaved data?"; answer$
        else
            answer$="yes"
        end if
        if answer$="yes" then
            JT.MaxTextLines=JT.DisplayLines*2 : JT.TotalLines=0
            JT.CurX=0 : JT.CurY=0 : JT.OffsetX=0 : JT.OffsetY=0
            JT.StartSelectX=0 : JT.StartSelectY=0 : JT.EndSelectX=0 : JT.EndSelectY=0 : JT.Highlight$=""
            redim JT.Text$(JT.MaxTextLines)
            call JTShowCursor
            call JTScrollDisplay
            #JTHandle$ "segment JT.SegID"
            #JTHandle$ "flush"
            call JTUpdateScreen
            call JTScrollDisplay
            if JT.JumpIsOpen then call JTSetupJumpWindow "All"
            JT.FileName$=""
        end if
    END SUB



    SUB JTLoadFile fileName$
        if fileName$<>"" then
            if fileExists(DefaultDir$, fileName$) then
                open fileName$ for input as #in
                L=0 : JT.TotalLines=0 : redim JT.Text$(JT.MaxTextLines)
                while not(eof(#in))
                    line input #in, JT.Text$(L)
                    L=L+1 : JT.TotalLines=JT.TotalLines+1
                    if L>JT.MaxTextLines then call JTRedoMaxTextLines
                wend
                JT.TotalLines=JT.TotalLines-1
                close #in
                #JTHandle$ "setfocus"
            else
                notice "error - file does not exist"
            end if
        end if
    END SUB

    SUB JTSaveFile fileName$
        if fileName$<>"" then
            open fileName$ for output as #out
            for L = 0 to JT.TotalLines
                #out JT.Text$(L)
            next L
            close #out
        end if
    end sub

    SUB JTGetSettings
        if fileExists(DefaultDir$,"JTSettings.dat") then
            open "JTSettings.dat" for input as #fin
                input #fin, JT.SyntaxHighlighting
                input #fin, JT.FileName$
                input #fin, JT.JumpIsOpen
                input #fin, JT.FontName$
                input #fin, JT.PathToJB$
            close #fin
        end if
    END SUB

    SUB JTSaveSettings
        open "JTSettings.dat" for output as #fout
            #fout, JT.SyntaxHighlighting
            #fout, JT.FileName$
            #fout, JT.JumpIsOpen
            #fout, JT.FontName$
            #fout, JT.PathToJB$
        close #fout
    END SUB

    '-------------------------------------------------------------------------------'
    '------------------------------                ---------------------------------'
    '++++++++++++++++++++++++++++++   FUNCTIONS    +++++++++++++++++++++++++++++++++'
    '------------------------------                ---------------------------------'
    '-------------------------------------------------------------------------------'

    FUNCTION fileExists(path$, filename$)
        'DIM fileExists.info$(10,10)   must be declared at the start of the prog.
        files path$, filename$, fileExists.info$()  ' path$ = 'DefaultDir$' generally.
        fileExists = val(fileExists.info$(0, 0))  'not zero if true
    END FUNCTION

    FUNCTION remove$(string$, drop$)
        if instr(string$, drop$) then remove$=mid$(string$,1,instr(string$,drop$)-1);mid$(string$,instr(string$,drop$)+len(drop$)) else remove$=string$
    END FUNCTION

    FUNCTION removeAll$(string$, drop$)
        while instr(string$, drop$)
            string$=remove$(string$, drop$)
        wend
        removeAll$=string$
    END FUNCTION

